<?php namespace App\Models;

use App\Entities\Procedimento\Procedimento;
use App\Utils\DateUtils;

class ProcedimentoModel extends ModelEntity
{
    protected $table = 'procedimento';
    protected $primaryKey = 'id';
    protected $returnType = 'array';
    protected $allowedFields = [
        'descricao',
        'criado_em',
        'alterado_em',
        'id_tipo_procedimento',
        'criado_por',
        'alterado_por',
    ];
    protected $useSoftDeletes = false;
    protected $skipValidation = true;
    protected $useTimestamps = true;
    protected $createdField  = 'criado_em';
    protected $updatedField  = 'alterado_em';

    public function registerProcedimento (Procedimento $procedimento) : void {
        $data = $procedimento->toArray(true);
        $id_procedimento = $this->insert($data);
        $procedimento->setId($id_procedimento);
    }

    public function updateProcedimentoByID (int $id_procedimento, Procedimento $procedimento) : bool {
        $data = $procedimento->toArray(true);
        $data['alterado_em'] = DateUtils::now();
        $binds = ['id_procedimento' => $id_procedimento];
        $sets = $this->generateUpdateSets($data, $binds);
        $sql = "update procedimento $sets where procedimento.id = :id_procedimento:";
//        log_message('error', $sql);
//        log_message('error', json_encode($data));
//        log_message('error', json_encode($binds));
        $query = $this->db->query($sql, $binds);
        return $query->connID->affected_rows === 1;
    }
}
